package com.ruoyi.ss.vip.service.impl;

import com.ruoyi.ss.vip.domain.Vip;
import com.ruoyi.ss.vip.service.VipConverter;
import com.ruoyi.ss.vip.utils.VipUtil;
import com.ruoyi.ss.vipOrder.domain.VipOrderVO;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

/**
 * @author wjh
 * 2025/1/18
 */
@Service
public class VipConverterImpl implements VipConverter {
    @Override
    public Vip toPo(VipOrderVO order) {
        if (order == null) {
            return null;
        }

        Vip vip = new Vip();
        vip.setUserId(order.getUserId());
        vip.setLevelId(order.getLevelId());
        vip.setStartTime(LocalDateTime.now());
        vip.setEndTime(LocalDateTime.now().plusDays(order.getSkuTime()));
        vip.setDiscount(order.getLevelDiscount());
        vip.setStoreId(order.getLevelStoreId());
        vip.setTotalCount(0);
        vip.setRoundCount(0);
        vip.setLimitType(order.getSkuLimitType());
        vip.setLimitCount(order.getSkuLimitCount());
        vip.setNextResetTime(VipUtil.getNextResetTime(LocalDateTime.now(), order.getSkuLimitType()));

        return vip;
    }
}
